"""
执行时需要继承Testunner这个类
不允许重载__init__函数
"""
from base.case_runner import TestRunner
from base.case_runner import excel_driver
import random


def random_name(name):
    return name + str(random.randint(1000, 9999))


# 仓库的相关数据替换--货主
def replace_warehouse_data(case, m_res):
    for data in m_res['warehouse_info']:
        if 'TEST_WAREHOUSE' in data['code']:
            case.request_data['selectedRows'][0]['warehouses']['rows'][0]['currentData']['warehouse_id'] = data['id']
            case.request_data['selectedRows'][0]['warehouses']['rows'][0]['currentData']['warehouse__code'] = data[
                'code']
            case.request_data['selectedRows'][0]['warehouses']['rows'][0]['currentData']['warehouse__name'] = data[
                'refer_code']
            break

    for data in m_res['staff_info']:
        if 'TEST_STAFF' in data['code']:
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['staff_num'] = data['name']
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['user_id'] = data[
                'ext__insert_user']
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['staff__code'] = data[
                'name']
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['staff__name'] = data[
                'name']
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['operator__username'] = data[
                'insert_user'].split('.')[-1]
            case.request_data['selectedRows'][0]['operators']['rows'][0]['currentData']['operator__common_name'] = data[
                'insert_user_common_name']
            break


# 批次仓库相关
def replace_warehouse_data_batch(case, m_res):
    for data in m_res['warehouse_info']:
        if 'TEST_WAREHOUSE' in data['code']:
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse_id'] = data['id']
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__code'] = data['code']
            case.request_data['selectedRows'][0]['header']['currentData']['warehouse__name'] = data['refer_code']
            break


def warehouse_config_parameter(case, m_res):
    # 仓库参数替换
    replace_warehouse_data_batch(case, m_res)
    # 在途批次和库存批次规则参数替换
    case.request_data['selectedRows'][0]['header']['currentData']['way_lot_rule_id'] = m_res['lot_rule_id']
    case.request_data['selectedRows'][0]['header']['currentData']['lot_rule_id'] = m_res['lot_rule_id']
    # 入库验证规则
    case.request_data['selectedRows'][0]['header']['currentData']['in_validation_rule_id'] = m_res['rule_in_validation_id']
    # 出库验证规则
    case.request_data['selectedRows'][0]['header']['currentData']['out_validation_rule_id'] = m_res['rule_out_validation_id']
    # 库位混放规则
    case.request_data['selectedRows'][0]['header']['currentData']['loc_mix_rule_id'] = m_res['rule_mix_storage_id']
    # 容器混放规则
    case.request_data['selectedRows'][0]['header']['currentData']['cup_mix_rule_id'] = m_res['rule_mix_storage_id']
    # 周转规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_rotate_id'] = m_res['zhouzhuan_id']
    # 上架规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_putaway_id'] = m_res['shangjia_id']
    # 分配规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_allocate_id'] = m_res['rule_allocate_id']
    # 切分规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_cutbox_id'] = m_res['rule_cutbox_id']
    # 波次规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_wave_id'] = m_res['rule_wave_id']
    # 拣选规则
    case.request_data['selectedRows'][0]['header']['currentData']['rule_pick_order_id'] = m_res['jianxuan_id']


# 商品名称替换
def replace_good_name(case, m_res):
    name = random_name('test_good')
    case.request_data['selectedRows'][0]['header']['currentData']['code'] = name
    case.request_data['selectedRows'][0]['header']['currentData']['refer_code'] = name
    case.request_data['selectedRows'][0]['header']['currentData']['name'] = name


@excel_driver('D:\Gitee\\test_data/testcase.xlsx')
class BaseData(TestRunner):
    # 重写用例执行前的方法
    def before_parameter(self, case, mid_res):
        """
            case-- 用例对象，可通过case.name这里的名字与excel中的字段对应即可
            mid_res-- 保存的中间结果
        """
        if case.name == '新增货主':
            replace_warehouse_data(case, mid_res)
        elif case.name in ['创建批次规则', '创建混放规则', '创建收货验证规则',
                           '创建周转规则', '创建上架规则', '创建上架规则明细',
                           '创建分配规则', '创建预分配规则', '创建切分规则', '创建波次规则',
                           '创建拣选规则', '创建拣选明细', '创建发货验证规则']:
            replace_warehouse_data_batch(case, mid_res)
        elif case.name == '创建仓库参数配置':
            warehouse_config_parameter(case, mid_res)
        elif case.name == '创建商品信息':
            replace_good_name(case, mid_res)


if __name__ == '__main__':
    BaseData().run_test()
